#
# spec file for package libunwind
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           libunwind
Version:        1.1
Release:        15.3.1
Summary:        Unwind Library
License:        MIT
Group:          System/Base
Url:            http://savannah.nongnu.org/projects/libunwind/
Source0:        http://download.savannah.gnu.org/releases/libunwind/libunwind-%{version}.tar.gz
Source1:        http://download.savannah.gnu.org/releases/libunwind/libunwind-%{version}.tar.gz.sig
Source2:        %{name}.keyring
Source3:        baselibs.conf
Patch0:         libunwind-1.1-tests.diff
#PATCH-FIX-UPSTREAM: upstream commit ae3dd9417a3d178cf51ce744d85b695dbf025b44
Patch1:         libunwind-1.1-expected-fails.patch
# PATCH-FIX-UPSTREAM: upstream commit ac6c0a6
Patch2:         libunwind-aarch64.patch
# PATCH-FIX-UPSTREAM: uweigand@de.ibm.com -- submitted to libunwind-devel
Patch3:         libunwind-ppc64le.patch
# PATCH-FIX-UPSTREAM: bnc#936786 CVE-2015-3239
Patch4:         libunwind-CVE-2015-3239.patch
# PATCH-FIX-UPSTREAM: boo#976955
Patch5:         0001-Mark-run-ptrace-mapper-and-run-ptrace-misc-as-XFAIL-.patch
# PATCH-FIX-UPSTREAM: boo#976955
Patch6:         0002-Mark-run-ptrace-mapper-and-run-ptrace-misc-as-XFAIL-.patch
BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  libatomic_ops-devel
BuildRequires:  libtool
BuildRequires:  pkg-config
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
ExclusiveArch:  %ix86 ia64 x86_64 %arm ppc ppc64 ppc64le aarch64

%description
A portable and efficient C programming interface (API) to determine the
call chain of a program.

%package devel
Summary:        Unwind library
Group:          Development/Libraries/C and C++
Requires:       libunwind = %{version}-%{release}
Provides:       libunwind:%{_libdir}/libunwind.so

%description devel
A portable and efficient C programming interface (API) to determine the
call-chain of a program.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1

%build
autoreconf -fvi
%configure
make %{?_smp_mflags}

%check
%if ! 0%{?qemu_user_space_build:1}
make check %{?_smp_mflags} || :
%endif

%install
make DESTDIR=%{buildroot} install %{?_smp_mflags}
find %{buildroot} -type f -name "*.la" -delete -print
mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libunwind.so.8* %{buildroot}/%{_lib}
ln -sf /%{_lib}/libunwind.so.8 %{buildroot}%{_libdir}/libunwind.so
# Check that ln did not create a dangling link
stat %{buildroot}/$(readlink -f "%{buildroot}/%{_libdir}/libunwind.so");

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-, root, root)
/%{_lib}/lib*
%{_libdir}/lib*.so.*
%{_libdir}/libunwind.so

%files devel
%defattr(-, root, root)
%{_includedir}/*
%{_libdir}/lib*.a
%{_libdir}/libunwind-*.so
%{_libdir}/pkgconfig/libunwind-generic.pc
%{_libdir}/pkgconfig/libunwind-ptrace.pc
%{_libdir}/pkgconfig/libunwind-setjmp.pc
%{_libdir}/pkgconfig/libunwind.pc
%ifarch %arm %ix86 x86_64 aarch64
%{_libdir}/pkgconfig/libunwind-coredump.pc
%endif
%doc %{_mandir}/man?/*

%changelog
* Sun Apr 24 2016 matwey.kornilov@gmail.com
- Add patches for boo#976955:
  * 0001-Mark-run-ptrace-mapper-and-run-ptrace-misc-as-XFAIL-.patch
  * 0002-Mark-run-ptrace-mapper-and-run-ptrace-misc-as-XFAIL-.patch
* Thu Jul  2 2015 tchvatal@suse.com
- Add patch for bnc#936786 CVE-2015-3239, off by one:
  * libunwind-CVE-2015-3239.patch
* Sun Mar 29 2015 meissner@suse.com
- added baselibs.conf for -xxbit packages
  This fixes a dependency issue with libzmq5 on openSUSE Leap 42.3
  ((boo#1122012))
* Wed Mar  4 2015 mpluskal@suse.com
- Use url for source
- Add gpg signature
* Mon May 19 2014 tchvatal@suse.com
- Clean up with spec-cleaner
- Add dependency over libatomic_opts that was missing
- Do not disable fortify-sources as it seems to work with it anyway
* Tue Dec 17 2013 uweigand@de.ibm.com
- libunwind-ppc64le.patch: Add support for ppc64le
* Wed Dec 11 2013 dvaleev@suse.com
- add ppc64le
* Mon Aug 12 2013 schwab@suse.de
- libunwind-aarch64.patch: Add support for AArch64 from upstream
* Sat Jan 26 2013 dmueller@suse.com
- filelist fix for ARM
* Tue Dec 11 2012 dvaleev@suse.com
- update to libunwind 1.1:
    coredump unwind support
    New arch: SuperH
    Improved support for PowerPC, ARM
    Lots of cleanups, perf tweaks
    pkg-config support
- drop all upstreamed patches
- refresh libunwind-1.1-tests.diff patch
- enable ppc ppc64 build
- Mark some tests as expected to fail
  libunwind-1.1-expected-fails.patch
* Mon Aug 20 2012 agraf@suse.com
- add support for ARM
* Mon Mar  5 2012 dmueller@suse.de
- remove build from ARM
* Thu Feb  9 2012 jengelh@medozas.de
- Remove redundant tags/sections
- Fix dangling symlink /usr/lib/libunwind.so (which was
  pointing at "libunwind.so.8.*", verbatim asterisk)
- Throw out .la file
* Wed Nov 23 2011 coolo@suse.com
- add libtool as buildrequire to avoid implicit dependency
* Mon Nov  7 2011 dmueller@suse.de
- disable testsuite when running under qemu
* Mon Oct 17 2011 dmueller@suse.de
-  update to libunwind 1.0.1:
  * hundreds of fixes, see http://git.savannah.gnu.org/gitweb/?p=libunwind.git;a=shortlog
    for details
  * ARM support
  * Greatly improved x86-64 support thanks to Arun Sharma.
  * Support for PPC64 added by  Jose Flavio Aguilar Paulino.
  * Testing, stability and many fixes on x86 (Paul Pluzhnikov)
  * Improved local and remote unwinding on ARM (Ken Werner)
  * Fast unwind (rbp, rsp, rip only) on x86_64 with a fallback to slow code paths
* Sun Oct 31 2010 jengelh@medozas.de
- Use %%_smp_mflags
* Thu Jan 28 2010 rguenther@suse.de
- Build without _FORTIFY_SOURCE, recent glibc fortify longjmp which
  confuses libunwind a lot and breaks the build.
* Thu Oct 15 2009 marek.belisko@open-nandra.com
- Fix typo in Gtest-dyn1.c (bnc#531705)
* Mon Jan 26 2009 schwab@suse.de
- Fix overlapping memcpy.
* Tue May 13 2008 schwab@suse.de
- Update to libunwind 0.98.6.
  * * Fix address-leak triggered by invalid byte-order.  Fixed by Andreas Schwab.
  * * On ia64, get_static_proc_name() no longer uses a weak reference to
    _Uelf64_get_proc_name(), since that was causing problems with archive
    libraries and no longer served any apparent purpose.  Fixed by
    Curt Wohlgemuth.
* Fri Apr 18 2008 rguenther@suse.de
- Fix build.
* Wed Jun  6 2007 schwab@suse.de
- Fix memory leak.
* Thu Jan 26 2006 schwab@suse.de
- Run ldconfig.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Nov 14 2005 schwab@suse.de
- Undo last change.
* Mon Oct 31 2005 dmueller@suse.de
- build with nonexecutable stack
* Fri Jul 22 2005 schwab@suse.de
- Remove broken tests.
* Mon May  2 2005 schwab@suse.de
- Fix broken test.
* Sat Apr 23 2005 schwab@suse.de
- Only libunwind needs to be in /lib.
- There are no expected testsuite failures on ia64 any more.
* Thu Apr 21 2005 schwab@suse.de
- Update to libunwind 0.98.5.
* Fri Feb 25 2005 schwab@suse.de
- Update to libunwind 0.98.4.
* Thu Feb  3 2005 schwab@suse.de
- Fix libdir.
- Fix warning.
* Tue Dec  7 2004 schwab@suse.de
- Update to libunwind 0.98.3.
* Sun Nov 14 2004 schwab@suse.de
- Don't move around libtool libraries.
* Sun Nov 14 2004 schwab@suse.de
- Split off libunwind-devel.
- Move library to /lib.
- Remove broken test.
* Fri Nov  5 2004 schwab@suse.de
- Update to libunwind 0.98.2.
* Thu Oct 28 2004 schwab@suse.de
- Update to libunwind 0.98.1.
* Wed Sep 29 2004 schwab@suse.de
- Fix installed headers.
* Thu Sep  9 2004 schwab@suse.de
- Update to libunwind 0.98.
- Enable building on x86_64.
* Thu Aug 19 2004 schwab@suse.de
- Update to libunwind 0.97.
* Sun Apr 18 2004 schwab@suse.de
- Pacify autobuild.
* Fri Dec  5 2003 schwab@suse.de
- Update to libunwind 0.96.
* Thu Dec  4 2003 schwab@suse.de
- Update to libunwind 0.95.
* Fri Sep 26 2003 schwab@suse.de
- Update to libunwind 0.93.
* Wed Jul 23 2003 schwab@suse.de
- Fix typo in specfile.
* Thu Jul 11 2002 schwab@suse.de
- Initial version.
